<?php

declare(encoding='UTF-8');

class Jolt_Route_Restful extends Jolt_Route {
	
	private $resource = NULL;
	
	public function __construct($route, $resource) {
		$this->setRoute($route)
			->setResource($resource);
	}
	
	public function setResource($resource) {
		$resource = trim($resource);
		if ( true === empty($resource) ) {
			throw new Jolt_Exception('route_restful_resource_empty');
		}
		
		$this->resource = $resource;
		return $this;
	}
	
	public function getResource() {
		return $this->resource;
	}
	
	public function isEqual(Jolt_Route $route) {
		return (
			$route instanceof Jolt_Route_Restful &&
			$this->getRoute() === $route->getRoute() &&
			$this->getResource() === $route->getResource()
		);
	}
	
	public function isValid() {
		$route = $this->getRoute();
		
		/* Special case of a valid route. */
		if ( '/' == $route ) {
			return true;
		}
		
		if ( 0 === preg_match('#^/([a-z]+)([a-z0-9_\-]*)$#i', $route) ) {
			return false;
		}
		
		return true;
	}
	
	public function isValidPath($uri) {
		$route = trim($this->getRoute());
		return ( $route === trim($uri));
	}
	
}